# IRsLEPanel Interface Reference

Inherits IRsPanel.

List of all members.

## Public Member Functions
HRESULT | CreatePanel ([in] IRsLEPanelData *pInitData)
HRESULT | DestroyPanel (void)
HRESULT | CreatePanelWindow ([in] POINT pos)
HRESULT | DestroyPanelWindow (void)
HRESULT | GetBoundingRect ([out, retval] RECT *rc)
HRESULT | GetBoundingRegion ([out, retval] HRGN *hRgn)
HRESULT | GetHandle ([out, retval] HWND *hWnd)
HRESULT | HighlightPanel ([in] RtUlong ulIntensity)
HRESULT | UpdateByNode (void)
HRESULT | UpdateConByNode ([in] CONID idCon)
HRESULT | GetConnReferencePoint ([in] CONID idCon,[out, retval] POINT *pPoint)
HRESULT | GetConnByPoint ([in] POINT pPoint,[out, retval] CONID *idCon)
HRESULT | GetPanelOwner ([out] IRsPanelOwner **pPanelOwner)
HRESULT | HighlightConn ([in] CONID idCon,[in] RtUlong ulIntensity)
HRESULT | AttachToNode ([in] IRsNode *pNode)
HRESULT | SetBehaviourFlags ([in] RtUlong ulFlags)
HRESULT | GetBehaviourFlags ([out] RtUlong *ulFlags)
HRESULT | SetAspect ([in] RtUlong ulAspect)
HRESULT | GetAspect ([out] RtUlong *ulAspect)
HRESULT | PutPanelId ([in] GUID idPanel)
HRESULT | GetPanelId ([out] GUID *idPanel)
HRESULT | AddNewControl ([in] IID *piid,[in] CONID idCon,[in] POINT *pPoint)
HRESULT | CloneControl ([in] IRsUIControl *ppSrc,[in] RECT *tgPos)
HRESULT | ChangeSelControl ([in] IID *idControlType)
HRESULT | AssignToIcon ([in] IID *idControlType,[in] CONID idCon)
HRESULT | GetSelConnDesc ([out, retval] IRsConDescriptor **ppConnDesc)
HRESULT | GetSelControl ([out, retval] IRsUIControl **ppControl)
HRESULT | PutPanelOwner ([in] IRsPanelOwner *pPanelOwner)
HRESULT | GetAllAspects ([out, retval] LPSAFEARRAY *saAspects)
HRESULT | GetAttachedNode ([out, retval] IRsNode **spNode)
HRESULT | StoreUITable (void)
HRESULT | UpdateValues (void)
HRESULT | UpdateByPanelProp (void)
HRESULT | ClosePanelProp (void)
HRESULT | UpdateUITable ([in] RtUlong flag)
HRESULT | GetEditState ([out] RtUlong *ulState)
HRESULT | ChangeEditState ([in] RtUlong ulEditState)
HRESULT | UpdateByControlDialog ([in] int cmd=0)
HRESULT | CloseControlDialog (void)
HRESULT | GetAspectName ([in] RtUlong ulAspect,[out, retval] BSTR *bsName)
HRESULT | GetBkgColor ([out] COLORREF *col)

## Detailed Description

The IRsLEPanel interface provides methods for LE panel.

## Member Function Documentation

HRESULT IRsLEPanel::CreatePanel | ( | [in] IRsLEPanelData * | pInitData | ) |

Create LE Panel according to initialize data.

Parameters:

  | pInitData | [in] Initialize data.

HRESULT IRsLEPanel::DestroyPanel | ( | void |  | ) |

Destroy LE panel.

HRESULT IRsLEPanel::CreatePanelWindow | ( | [in] POINT | pos | ) |

Create LE Panel window.

Parameters:

  | pos | [in] Position of created window.

HRESULT IRsLEPanel::DestroyPanelWindow | ( | void |  | ) |

Destroy LE Panel window.

HRESULT IRsLEPanel::GetBoundingRect | ( | [out, retval] RECT * | rc | ) |

Get bounding rectangle of LE panel window.

Returns:
  rc [out, retval] Pointer to a structure that receives the coordinates of bounding box rectangle of the window.

Implements IRsPanel.

HRESULT IRsLEPanel::GetBoundingRegion | ( | [out, retval] HRGN * | hRgn | ) |

Get bounding region if LE panel window.

Returns:
  hRgn [out, retval] Pointer to a structure that receives the coordinates of bounding region of the window.

Implements IRsPanel.

HRESULT IRsLEPanel::GetHandle | ( | [out, retval] HWND * | hWnd | ) |

Get handle of LE panel window.

Returns:
  hWnd [out, retval] Pointer to a structure that receives the handle of LE panel window.

Implements IRsPanel.

HRESULT IRsLEPanel::HighlightPanel | ( | [in] RtUlong | ulIntensity | ) |

Set intensity of panel, this will change background color of title window.

Parameters:

  | ulIntensity | [in] Intensity value.

Implements IRsPanel.

HRESULT IRsLEPanel::UpdateByNode | ( | void |  | ) |

Update LE panel data by Node.

HRESULT IRsLEPanel::UpdateConByNode | ( | [in] CONID | idCon | ) |

Update LE panel connector data according to node.

Parameters:

  | idCon | [in] id of connector which will be updated.

HRESULT IRsLEPanel::GetConnReferencePoint | ( | [in] CONID | idCon,
|  | [out, retval] POINT * | pPoint |
| ) |  |  |

Get specific connector reference point.

Parameters:

  | idCon | [in] id of connector which will be referenced.

Returns:
  pPoint [out, retval] Pointer to a structure that receives the coordinates of connector reference point.

HRESULT IRsLEPanel::GetConnByPoint | ( | [in] POINT | pPoint,
|  | [out, retval] CONID * | idCon |
| ) |  |  |

Get specific connector by point.

Parameters:

  | pPoint | [in] Structure that contained coordinates of point.

Returns:
  idCon [out, retval] Pointer to a structure that receives the connector ID.

HRESULT IRsLEPanel::GetPanelOwner | ( | [out] IRsPanelOwner ** | pPanelOwner | ) |

Get LE panel owner.

Parameters:

  | pPanelOwner | [out] Pointer to a structure that receives the panel owner.

HRESULT IRsLEPanel::HighlightConn | ( | [in] CONID | idCon,
|  | [in] RtUlong | ulIntensity |
| ) |  |  |

Highlight Connector.

Parameters:

  | idCon | [in] Id of connector that will be highlighted.
  | ulIntensity | [in] Intensity value.

HRESULT IRsLEPanel::AttachToNode | ( | [in] IRsNode * | pNode | ) |

Attach LE panel to node.

Parameters:

  | pNode | [in] Interface of node, that will be attached to LE panel.

HRESULT IRsLEPanel::SetBehaviourFlags | ( | [in] RtUlong | ulFlags | ) |

Sets LE panel's behaviour flags.

Parameters:

  | ulFlags | [in] Behaviour flags. See list of possible values: PANEL_HIDETITLE hide title. PANEL_TITLE_HIDEROOT hide root in title. PANEL_TITLE_HIDEASPBTN hide aspect button in title bar. PANEL_TITLE_HIDECLOSEBNT hide close button in title bar. PANEL_EDITOR_DISABLED disable editor. PANEL_DISABLEASPECTCHANGE disable aspect change. PANEL_MENUDISABELED disable menu. PANEL_DISABLERENAME disable rename. PANEL_DISABLECLOSE disable close. PANEL_TITLE_HIDEICON hide icon in title. PANEL_DISABLE_CONTROLSREPOSITIONING disable control repositioning. PANEL_DISABLE_UITABLERESAVE disable UI table resave. PANEL_TITLE_HIDEICONIZE hide iconize mode.

HRESULT IRsLEPanel::GetBehaviourFlags | ( | [out] RtUlong * | ulFlags | ) |

Get LE panel's behaviour flags.

Parameters:

  | ulFlags | [out] Pointer to a variable of type RtUlongm that retrieves behaviour flags. See list of possible values: PANEL_HIDETITLE hide title. PANEL_TITLE_HIDEROOT hide root in title. PANEL_TITLE_HIDEASPBTN hide aspect button in title bar. PANEL_TITLE_HIDECLOSEBNT hide close button in title bar. PANEL_EDITOR_DISABLED disable editor. PANEL_DISABLEASPECTCHANGE disable aspect change. PANEL_MENUDISABELED disable menu. PANEL_DISABLERENAME disable rename. PANEL_DISABLECLOSE disable close. PANEL_TITLE_HIDEICON hide icon in title. PANEL_DISABLE_CONTROLSREPOSITIONING disable control repositioning. PANEL_DISABLE_UITABLERESAVE disable UI table resave. PANEL_TITLE_HIDEICONIZE hide iconize mode.

HRESULT IRsLEPanel::SetAspect | ( | [in] RtUlong | ulAspect | ) |

Set active LE panel aspect based on its index.

Parameters:

  | ulAspect | [in] Index of aspect which will be selected.

HRESULT IRsLEPanel::GetAspect | ( | [out] RtUlong * | ulAspect | ) |

Get active LE panel aspect index.

Parameters:

  | ulAspect | [out] Pointer to a variable of type RtUlong, that retrieves index of active aspect.

HRESULT IRsLEPanel::PutPanelId | ( | [in] GUID | idPanel | ) |

Puts LE panel Id.

Parameters:

  | idPanel | [in] New panel GUID.

HRESULT IRsLEPanel::GetPanelId | ( | [out] GUID * | idPanel | ) |

Gets LE panel Id.

Parameters:

  | idPanel | [out] Pointer to a variable of type GUID, that retrieves GUID of panel.

HRESULT IRsLEPanel::AddNewControl | ( | [in] IID * | piid,
|  | [in] CONID | idCon,
|  | [in] POINT * | pPoint |
| ) |  |  |

Add new control to LE panel.

Parameters:

  | piid | [in] Pointer to the interface id.
  | idCon | [in] Connecor's id.
  | pPoint | [in] Pointer to a variable of type POINT that contain coordinates of new control position in pixels.

HRESULT IRsLEPanel::CloneControl | ( | [in] IRsUIControl * | ppSrc,
|  | [in] RECT * | tgPos |
| ) |  |  |

Clone control and put it at new position in LE panel.

Parameters:

  | ppSrc | [in] Component to clone.
  | tgPos | [in] position, where to place new control.

HRESULT IRsLEPanel::ChangeSelControl | ( | [in] IID * | idControlType | ) |

Change selected control type.

Parameters:

  | idControlType | [in] Pointer to the control type interface id.

HRESULT IRsLEPanel::AssignToIcon | ( | [in] IID * | idControlType,
|  | [in] CONID | idCon |
| ) |  |  |

Set iconized aspect to control with type equal "idControlType".

Parameters:

  | idControlType | [in] Pointer to the control type interface id.
  | idCon | [in] Connector's id.

HRESULT IRsLEPanel::GetSelConnDesc | ( | [out, retval] IRsConDescriptor ** | ppConnDesc | ) |

Gets selected connector descriptor.

Returns:
  ppConnDesc [out, retval] Pointer to the IRsConDescriptor interface, that retrieves selected connector descriptor.

HRESULT IRsLEPanel::GetSelControl | ( | [out, retval] IRsUIControl ** | ppControl | ) |

Gets selected UI control.

Returns:
  ppControl [out, retval] Pointer to the IRsUIControl interface, that retrieves selected connector.

HRESULT IRsLEPanel::PutPanelOwner | ( | [in] IRsPanelOwner * | pPanelOwner | ) |

Put panel owner.

Parameters:

  | pPanelOwner | [in] Interface of new panel owner.

HRESULT IRsLEPanel::GetAllAspects | ( | [out, retval] LPSAFEARRAY * | saAspects | ) |

Get all aspects names array.

Returns:
  saAspects [out, retval] Pointer to a variable of type LPSAVEARRAY, that retrieves all aspects of LE panel.

HRESULT IRsLEPanel::GetAttachedNode | ( | [out, retval] IRsNode ** | spNode | ) |

Get attached node to LE panel.

Returns:
  spNode [out, retval] Pointer to the IRsNode interface, that retrieves interface of node, attached to the LE panel.

HRESULT IRsLEPanel::StoreUITable | ( | void |  | ) |

Store UI table.

HRESULT IRsLEPanel::UpdateValues | ( | void |  | ) |

Update values.

HRESULT IRsLEPanel::UpdateByPanelProp | ( | void |  | ) |

Update LE panel properties by dialog input.

HRESULT IRsLEPanel::ClosePanelProp | ( | void |  | ) |

Change edit state, close additional tool bars for edition and properties windows.

HRESULT IRsLEPanel::UpdateUITable | ( | [in] RtUlong | flag | ) |

Update UI table.

Parameters:

  | flag | [in] Parameter is not used.

HRESULT IRsLEPanel::GetEditState | ( | [out] RtUlong * | ulState | ) |

Gets edit state of LE panel.

Parameters:

  | ulState | [out] Pointer to a variable of type RtUlong that retrieves edit state flag of LE panel. See list of possible values: PANEL_EDIT_NONE no edit. PANEL_EDIT_MAINLIB edit main library. PANEL_EDIT_ATTRIBLIB edit attribute library. PANEL_EDIT_PANELPROP edit panel properties. PANEL_EDIT_CONTROLPROP edit control properties. PANEL_EDIT_CONTROLLIB edit control library. PANEL_EDIT_ALLCTRLSLIB edit all controls library. PANEL_EDIT_BORDERPROP edit border properties. PANEL_EDIT_CONTROLDIALOG edit control dialog.

HRESULT IRsLEPanel::ChangeEditState | ( | [in] RtUlong | ulEditState | ) |

Modifies edit state of LE panel.

Parameters:

  | ulEditState | [in] LE edit state flags. See list of possible values:

- PANEL_EDIT_NONE no edit.
- PANEL_EDIT_MAINLIB edit main library.
- PANEL_EDIT_ATTRIBLIB edit attribute library.
- PANEL_EDIT_PANELPROP edit panel properties.
- PANEL_EDIT_CONTROLPROP edit control properties.
- PANEL_EDIT_CONTROLLIB edit control library.
- PANEL_EDIT_ALLCTRLSLIB edit all controls library.
- PANEL_EDIT_BORDERPROP edit border properties.
- PANEL_EDIT_CONTROLDIALOG edit control dialog.

Remarks:
  If ulState is less then 0, layout version is not fixed to the newest.

HRESULT IRsLEPanel::UpdateByControlDialog | ( | [in] int | cmd = `0` | ) |

Update LE panel by UI control properties dialog.

Parameters:

  | cmd | [in] Value specifies additional command which will be proceeded: 0 - None update command. 1 - Swap width and height. 2 - Recreate.

HRESULT IRsLEPanel::CloseControlDialog | ( | void |  | ) |

Change edit state, close additional tool bars for edition and properties windows.

HRESULT IRsLEPanel::GetAspectName | ( | [in] RtUlong | ulAspect,
|  | [out, retval] BSTR * | bsName |
| ) |  |  |

Get LE panel aspect's name by aspect index.

Parameters:

  | ulAspect | [in] Value of LE aspect index.

Returns:
  bsName [out, retval] Pointer to a variable that retrieves name of aspect corresponding with specified aspect index.

HRESULT IRsLEPanel::GetBkgColor | ( | [out] COLORREF * | col | ) |

Get panel background color.

Parameters:

  | COLORREF | *col [out] color.